#define lcd_rs_pin 6
#define lcd_enable_pin 10
#define lcd_d4_pin 9
#define lcd_d5_pin 8
#define lcd_d6_pin 19
#define lcd_d7_pin 15

#define lcdBackLightPin LED_BUILTIN
#define tachoSensor 5

#include <LiquidCrystal.h>
// configuring LCD data pins
LiquidCrystal lcd(lcd_rs_pin, lcd_enable_pin, lcd_d4_pin, lcd_d5_pin, lcd_d6_pin, lcd_d7_pin);


#include "2s_tasks.h"


const unsigned int constLoopIntervalMs = 200;

unsigned int loopCount; // counts
unsigned long varLastLoopTime;

void setup() {
  // set up the LCD's number of columns and rows:
  lcd.begin(20, 4);

  pinMode(lcdBackLightPin, OUTPUT);
  digitalWrite(lcdBackLightPin, HIGH);
  pinMode(tachoSensor, INPUT);
  attachInterrupt(digitalPinToInterrupt(tachoSensor), tachoUpdate, FALLING);
  lcd.clear();
}

void loop() {

  if ((millis() - varLastLoopTime) > constLoopIntervalMs) { // check time since last loop counter update
  loopCount ++; // update loop count
  if (loopCount > 10) loopCount = 0; // if loop count has eceeded 10 reset
    varLastLoopTime = millis();
  }

  if (loopCount == 10){
    task2s();
  }
  
}
