
 volatile unsigned int tachoDistanceCounts; // total counts of sensor from power up
volatile int16_t vTachoSpeedCounts;
int tachoStep = 23;
uint32_t v_LastSpeedTime;


void tachoUpdate() {
  vTachoSpeedCounts ++;
  tachoDistanceCounts ++;  
}


void u16toa(unsigned int vartoconvert, char *string) {

  unsigned char tempstring[6];
  uint8_t tempcounter = 0;
  uint8_t stringcounter = 0;
  unsigned int var = vartoconvert;

  tempstring[0] = 0;

  while (var > 9) {
    tempcounter++;
    tempstring[tempcounter] = (var % 10) + 48;
    var = var / 10;
  }
  tempcounter++;
  tempstring[tempcounter] = (var % 10) + 48;

  while (tempcounter != 0) {
    string[stringcounter] = tempstring[tempcounter];
    tempcounter--;
    stringcounter++;
  }
}

void asciiDistance(long vartoconvert, char *string) {

  unsigned char tempstring[15];
  uint8_t tempcounter = 0;
  uint8_t stringcounter = 0;
  long var = vartoconvert;

  tempstring[0] = 0;

  while (var > 0) {
    tempcounter++;
    if (tempcounter == 2) {
      tempstring[tempcounter] = '.';
      tempcounter ++;
    }
    tempstring[tempcounter] = (var % 10) + 48;
    var = var / 10;
  }

  if (vartoconvert < 10) {
    tempstring[2] = '.';
    tempstring[3] = '0';
    tempcounter = 3;
  }

  while (tempcounter != 0) {
    string[stringcounter] = tempstring[tempcounter];
    tempcounter--;
    stringcounter++;
  }
}

void lcdDistancePrint() {
  noInterrupts();
  long distance =  tachoDistanceCounts * tachoStep / 100;
  char text[6] = {0, 0, 0, 0, 0, 0};
  char counter = 0;
  char temp;

  asciiDistance(distance, text);
  lcd.print("Distance ");
  while (text[counter] != 0) {
    temp = text[counter];
    lcd.write(temp);
    counter ++;
  }
  lcd.print(" m");
  counter = 0;
}

void lcdSpeedPrint() {
  
  //uint32_t varCurrentSpeedTime = millis();

  uint32_t tempvarTime =  millis();
  uint32_t vtSpeed = (vTachoSpeedCounts * tachoStep * 600) / (tempvarTime - v_LastSpeedTime);
  uint16_t tvTimeDifference = (tempvarTime - v_LastSpeedTime);
  char text[6] = {0, 0, 0, 0, 0, 0};
  char counter = 0;
  char temp;
  /*
    asciiDistance(vtSpeed, text);
    lcd.print("Speed ");
    while (text[counter] != 0) {
      temp = text[counter];
      lcd.write(temp);
      counter ++;
    }
    lcd.print(" m/m");
    counter = 0;
  */
  lcd.print(millis()/1000);
  lcd.setCursor(0, 2);
  lcd.print(vTachoSpeedCounts);
  lcd.setCursor(0, 3);
  lcd.print((tempvarTime - v_LastSpeedTime));

  v_LastSpeedTime = millis();
  vTachoSpeedCounts = 0;
  interrupts();
}
